##############################################################################
# Product:  Test for "C+" Object Oriented Programming in C
# Version:  3.0
# Updated:  January 29, 2005
#
# Copyright (C) 2002-2005 Quantum Leaps. All rights reserved.
#
# This software may be distributed and modified under the terms of the
# BSD open source license, which is provided below.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer.
#
# Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# Neither the name of the Quantum Leaps nor the names of its contributors
# may be used to endorse or promote products derived from this software
# without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Contact information:
# Quantum Leaps Web site:  http://www.quantum-leaps.com
# Quantum Leaps licensing: http://www.quantum-leaps.com/licensing
# e-mail:                  sales@quatnum-leaps.com
##############################################################################

# Turbo C++ 1.01 directory
TCDIR = C:\TOOLS\TCPP101

CC = $(TCDIR)\BIN\TCC
LINK = $(TCDIR)\BIN\TLINK


CPLUS_INCDIR = ..\..\CPLUS\INCLUDE
CPLUS_LIBDIR = ..\..\CPLUS\DOSB1\RELEASE
INCDIR = ..\INCLUDE
SRCDIR = ..\SOURCE
BINDIR = RELEASE

# -c  : compile only
# -ml : memory model -- large
CCFLAGS = -c -ml -I$(CPLUS_INCDIR) -I$(INCDIR)

# /m  : map file with publics
LINKFLAGS = /m

CPLUS_DEP = $(CPLUS_INCDIR)\cplus.h
APP_DEP = $(INCDIR)\shape.h \
          $(INCDIR)\circle.h \
          $(INCDIR)\rect.h


$(BINDIR)\cplustst.exe : \
	$(BINDIR)\main.obj \
	$(BINDIR)\shape.obj \
	$(BINDIR)\circle.obj \
	$(BINDIR)\rect.obj \
	$(CPLUS_LIBDIR)\cplus.lib
	$(LINK) $(LINKFLAGS) @link.rsp 

$(BINDIR)\main.obj: main.c $(APP_DEP) $(CPLUS_DEP)
	$(CC) $(CCFLAGS) -o$< main.c 

$(BINDIR)\shape.obj: $(SRCDIR)\shape.c $(APP_DEP) $(CPLUS_DEP)
	$(CC) $(CCFLAGS) -o$< $(SRCDIR)\shape.c

$(BINDIR)\circle.obj: $(SRCDIR)\circle.c $(APP_DEP) $(CPLUS_DEP)
	$(CC) $(CCFLAGS) -o$< $(SRCDIR)\circle.c

$(BINDIR)\rect.obj: $(SRCDIR)\rect.c $(APP_DEP) $(CPLUS_DEP)
	$(CC) $(CCFLAGS) -o$< $(SRCDIR)\rect.c
